<!DOCTYPE html>
<html>

<head>
  <title> Task 520- Mid Modul</title>
  <meta charset="UTF-8">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container p-4 text-center">
    <div class="form-group"><h3><b>Danh Sách Bình Luận (comment) của bài viết.</b></h3></div>
    <div class="form-group">
      <label>Điền Post Id</label>
      <input type ="text" id= "inp-post-id" placeholder="Điền post id, ví dụ : 2, 3">
    </div>
    <div class="form-group">
      <button class="btn btn-success" id="btn-get-list-comment"> Lấy danh sách bình luận của bài viết</button>
    </div>
    <!-- TODO 1: Thêm 1 dòng mới thủ công ở table trên (thêm thủ công  bằng HTML) -->
    <table id="tbl-user-posts" class="table table-bordered table-striped">
      <thead>
        <!-- phần head, dòng tiêu đề  của bảng -->
        <tr>
          <td>Id </td>
          <td> Post Id </td>
          <td> Email </td>
          <td> Name (nhan đề)</td>
          <td> Body (nội dung) </td>
          <td> Action</td>
        </tr>
      </thead>
      <tbody>
        <!-- phần dữ liệu của bảng -->

      </tbody>
    </table>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gPostIdEle=$("#inp-post-id");
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();
      });
     
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        console.log("Tải trang...");
        $("#btn-get-list-comment").on("click", function(){
        var vPostIdObj= {postid:0};
        getDataUseToCallApi(vPostIdObj);
        var vIsOk=validateDataInp(vPostIdObj);
        if (vIsOk){
          callApiToGetUserPosts(vPostIdObj);
        }
        });
        
      
      }
      function onBtnDetailClick(paramBtnDetail) {
        console.log("Nut Edit đc bấm...");
        console.log("Post Id: " + $(paramBtnDetail).data("postId"));
        
        const gDETAIL_FORM_URL = "PostDetail.html";
        var vUrlSiteToOpen = gDETAIL_FORM_URL + "?" + "id=" + $(paramBtnDetail).data("id");
        window.location.href = vUrlSiteToOpen;
      }
     
      
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function getDataUseToCallApi(paramPostIdObj){
        paramPostIdObj.postid=gPostIdEle.val().trim();
       console.log(paramPostIdObj);
      }
      function validateDataInp(paramPostIdObj){
        if (isNaN(paramPostIdObj.postid)){
          alert ("Bạn hãy nhập Post Id");
          return false;
        }
        return true;
      }
      function callApiToGetUserPosts(paramPostIdObj) {
        "use strict";
        $.ajax({
          url: "https://jsonplaceholder.typicode.com/"+"posts/"+paramPostIdObj.postid+"/comments",
          type: "GET",
          dataType: "json",
          success: function (res) {
            console.log(res);
            loadDataUserPostToTable(res);
            $(".btn-detail").on("click", function () {
              onBtnDetailClick(this);
            });           
          },
          error: function (ajaxContext) {
            console.log(ajaxContext.responseText);
          },
        });
      }
      function loadDataUserPostToTable(paramUsersRes) {
        console.log("Load nè");
        for (var bI = 0; bI < paramUsersRes.length; bI++) {
          var vTable=$("#tbl-user-posts");
          var bNewRow = $("<tr>").appendTo(vTable);
          $("<td>").html(paramUsersRes[bI].id).appendTo(bNewRow);
          $("<td>").html(paramUsersRes[bI].postId).appendTo(bNewRow);
          $("<td>").html(paramUsersRes[bI].email).appendTo(bNewRow);
          $("<td>").html(paramUsersRes[bI].name).appendTo(bNewRow);
          $("<td>").html(paramUsersRes[bI].body).appendTo(bNewRow);
         
          //tạo cell vào row, gắn  nút vào cell, gắn thuộc tính  và hàm vào nút
          var bCellAction = $("<td>").appendTo(bNewRow);
          var bButtonEdit = $("<button>Chi Tiết</button>")
            .addClass("btn btn-info  btn-detail")
            .data("id",paramUsersRes[bI].id)
            .appendTo(bCellAction);
         
        }
      }
   
    </script>

</body>

</html>